#
# Copyright (C)  Heinz Mauelshagen, 2004-2008 Red Hat GmbH. All rights reserved.
#
# See file LICENSE at the top of this source tree for license information.
#

Summary: dmraid (Device-mapper RAID tool and library)
Name: dmraid
Version: 1.0.0.rc13
Release: 33%{?dist}
License: GPL
Group: System Environment/Base
URL: http://people.redhat.com/heinzm/sw/dmraid
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: device-mapper >= 1.02.02-2, libselinux-devel, libsepol-devel
Requires: kpartx
Source: ftp://people.redhat.com/heinzm/sw/dmraid/src/%{name}-%{version}.tar.bz2

Patch0: dmraid-1.0.0.rc13-format_updates.patch
Patch1: dmraid-1.0.0.rc13-jmicron-name.patch
Patch2: dmraid-1.0.0.rc13-partchar.patch
Patch3: dmraid-1.0.0.rc13-version.patch
Patch4: dmraid-1.0.0.rc13-partchar-1.patch
Patch5: dmraid-1.0.0.rc14-solitary-meta-block.patch
Patch6: dmraid-1.0.0.rc14-UUID.patch
#Patch7: dmraid-1.0.0.rc14-ERROR.patch
Patch8: dmraid-1.0.0.rc14-UUID-Subsystemprefix.patch
Patch9: dmraid-1.0.0.rc14-ddf1_group_info.patch
Patch10: dmraid-1.0.0.rc15-set_create_delete_events.patch
Patch11: dmraid-1.0.0.rc15-remove_zlib_header.patch
Patch12: dmraid-1.0.0.rc15-undef_check_format_handler.patch
Patch13: dmraid-1.0.0.rc13-RHEL5_error_handling.patch
Patch14: dmraid-1.0.0.rc15-isw_metadata_normal_state.patch
Patch15: dmraid-1.0.0.rc15-isw_rebuild.patch
Patch16: dmraid-1.0.0.rc13-17-version.patch
Patch17: dmraid-1.0.0.rc15-add_libdmraid-events.patch
Patch18: dmraid-1.0.0.rc15-add_event_tool.patch
Patch19: dmraid-1.0.0.rc15-add_logwatch_files.patch
Patch20: dmraid-1.0.0.rc15-add_dmevent_tool_man_page.patch
Patch21: dmraid-1.0.0.rc15-led_argument.patch
Patch22: dmraid-1.0.0.rc15-configure.patch
Patch23: dmraid-1.0.0.rc15-initialize_handler_info.patch

%description
DMRAID supports RAID device discovery, RAID set activation and display of
properties for ATARAID on Linux >= 2.4 using device-mapper.


%package -n dmraid-devel
Summary: Development libraries and headers for dmraid.
Group: Development/Libraries
Requires: dmraid = %{version}-%{release}

%description -n dmraid-devel
dmraid-devel provides a library interface for RAID device discovery,
RAID set activation and display of properties for ATARAID volumes.


%package -n dmraid-events
Summary: dmevent_tool (Device-mapper event tool) and DSO
Group: System Environment/Base
Requires: dmraid = %{version}-%{release}, logwatch, sgpio, smtpdaemon, /etc/cron.d

%description -n dmraid-events
Provides a dmeventd DSO and the dmevent_tool to register devices with it
for device failure monitoring and logwatch based email reporting.
Device failure montoring and reporting has to be activated manually
by activating /etc/cron.d/dmeventd entry and by calling the dmevent_tool
(see manual page for examples) for any active RAID sets.


%prep
%setup -q -n dmraid/%{version}
%patch0 -p2 -b .format_updates
%patch1 -p2 -b .jmicron-name
%patch2 -p2 -b .partchar
%patch3 -p2 -b .version
%patch4 -p2 -b .partchar-1
%patch5 -p1 -b .solitary-meta-block
%patch6 -p1 -b .UUID
#%%patch7 -p1 -b .ERROR
%patch8 -p1 -b .UUID-Subsystemprefix
%patch9 -p1 -b .ddf1_group_info
%patch10 -p2 -b .set_create_delete_events
%patch11 -p2 -b .remove_zlib_header
%patch12 -p2 -b .undef_check_format_handler
%patch13 -p2 -b .RHEL5_error_handling
%patch14 -p2 -b .isw_metadata_normal_state.patch
%patch15 -p2 -b .isw_rebuild.patch
%patch16 -p2 -b .version2
%patch17 -p2 -b .add_libdmraid-events.patch
%patch18 -p2 -b .add_event_tool.patch
%patch19 -p2 -b .add_logwatch_files.patch
%patch20 -p2 -b .add_dmevent_tool_man_page.patch
%patch21 -p2 -b .led_argument.patch
%patch22 -p2 -b .configure.patch
%patch23 -p2 -b .initialize_handler_info.patch

%build
%configure --prefix=${RPM_BUILD_ROOT}/usr --sbindir=${RPM_BUILD_ROOT}/sbin --libdir=${RPM_BUILD_ROOT}/%{_libdir} --mandir=${RPM_BUILD_ROOT}/%{_mandir} --includedir=${RPM_BUILD_ROOT}/%{_includedir} --enable-debug --enable-libselinux --enable-libsepol --enable-static_link --enable-led --enable-intel_led
make DESTDIR=$RPM_BUILD_ROOT
mv tools/dmraid tools/dmraid.static
make clean
%configure --prefix=${RPM_BUILD_ROOT}/usr --sbindir=${RPM_BUILD_ROOT}/sbin --libdir=${RPM_BUILD_ROOT}/%{_libdir} --mandir=${RPM_BUILD_ROOT}/%{_mandir} --includedir=${RPM_BUILD_ROOT}/%{_includedir} --enable-debug --enable-libselinux --enable-libsepol --disable-static_linko --enable-led --enable-intel_led
make DESTDIR=$RPM_BUILD_ROOT

%install
rm -rf $RPM_BUILD_ROOT
install -m 755 -d $RPM_BUILD_ROOT{%{_libdir},/sbin,%{_sbindir},%{_bindir},%{_libdir},%{_includedir}/dmraid/,/var/lock/dmraid,/etc/cron.d/,/etc/logwatch/conf/services/,/etc/logwatch/scripts/services/}
make DESTDIR=$RPM_BUILD_ROOT install

# Install static dmraid binary
install -m 755 tools/dmraid.static $RPM_BUILD_ROOT/sbin/dmraid.static

# Provide convenience link from dmevent_tool
(cd $RPM_BUILD_ROOT/sbin ; ln -f dmevent_tool dm_dso_reg_tool)
install -m 644 include/dmraid/*.h $RPM_BUILD_ROOT%{_includedir}/dmraid/

# If requested, install the libdmraid and libdmaraid-events (for dmeventd) DSO
install -m 755 lib/libdmraid.so \
	$RPM_BUILD_ROOT%{_libdir}/libdmraid.so.%{version}
(cd $RPM_BUILD_ROOT/%{_libdir} ; ln -sf libdmraid.so.%{version} libdmraid.so)
install -m 755 lib/libdmraid-events.so \
	$RPM_BUILD_ROOT%{_libdir}/libdmraid-events.so.%{version}
(cd $RPM_BUILD_ROOT/%{_libdir} ; ln -sf libdmraid-events.so.%{version} libdmraid-events.so)

# Install logwatch config file and script for dmeventd
install -m 644 logwatch/dmeventd.conf $RPM_BUILD_ROOT/etc/logwatch/conf/services/dmeventd.conf
install -m 755 logwatch/dmeventd $RPM_BUILD_ROOT/etc/logwatch/scripts/services/dmeventd
install -m 644 logwatch/dmeventd_cronjob.txt $RPM_BUILD_ROOT/etc/cron.d/dmeventd

rm -f $RPM_BUILD_ROOT/%{_libdir}/libdmraid.a

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc CHANGELOG CREDITS KNOWN_BUGS LICENSE LICENSE_GPL LICENSE_LGPL README TODO doc/dmraid_design.txt
/%{_mandir}/man8/dmraid*
/sbin/dmraid
/sbin/dmraid.static
%{_libdir}/libdmraid.so*
%{_libdir}/libdmraid-events.so*
/var/lock/dmraid

%files -n dmraid-devel
%defattr(-,root,root)
%dir %{_includedir}/dmraid
%{_includedir}/dmraid/*

%files -n dmraid-events
%defattr(-,root,root)
/%{_mandir}/man8/dmevent_tool*
/sbin/dmevent_tool
/sbin/dm_dso_reg_tool
%config(noreplace) /etc/logwatch/*
%config(noreplace) /etc/cron.d/dmeventd

%postun
# Remove any dmeventd stored script pattern file.
rm -fr /etc/logwatch/scripts/services/dmeventd_syslogpattern.txt

%changelog
* Mon Dec 15 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-33
- Add patch to cvs
- Resolves: rhbz#475385

* Fri Dec 12 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-32
- Initialize handler_info variable in activate.c
- Resolves: rhbz#475385

* Fri Dec 12 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-31
- manual pages not found due to wrong pattern
- Added /etc/cron.d/ to buildrout to avoid -D option to
  logwatch file install calls
- Related: rhbz#437169 rhbz#476123

* Fri Dec 12 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-30
- Added -D option to logwatch file install calls
- Related: rhbz#437169 rhbz#476123

* Fri Dec 12 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-29
- Fix dependencies
- Move event monitoring components into seperate package
- Remove activation scriptlet and let user decide to activate logwatch
  for syslog parsing and mail reporting (avoids selinux /tmp issue)
- Resolves: rhbz#476123
- Related: rhbz#437169

* Wed Dec 10 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-28
- Fix post/preun scriptlets to deal with service option overrides etc.
- Add LED configure options
- Resolves: rhbz#474757 rhbz#475539
- Related: rhbz#437169

* Tue Dec 09 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-27
- Fixed led() function prototype
- Related: rhbz#437169

* Tue Dec 09 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-26
- Fixed compile flaw with LED_* symbols in libdmraid-events.c
- Related: rhbz#437169

* Mon Dec 08 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-25
- Added logwatch package to required ones
- Related: rhbz#437169

* Fri Dec 05 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-24
- Rebuild to test
- Related: rhbz#437169

* Fri Dec 05 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-23
- Fixed missing library in DSO build (Intel test report)
- Related: rhbz#437169

* Fri Dec 05 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-22
- version bumped + another specfile fix
- Related: rhbz#437169

* Fri Dec 05 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-21
- version bumped
- Related: rhbz#437169

* Fri Dec 05 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-21
- specfile %files correction
- Related: rhbz#437169

* Fri Dec 05 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-20
- Add missing vixie-crontab requirement
- Resolves: rhbz#474757

* Wed Dec 03 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-19
- Fixed Makefile flaw and rebuild
- Related: rhbz#437169

* Wed Dec 03 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-18
- Add dmevent_tool manual page
- Related: rhbz#437169

* Wed Dec 03 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-17
- Add event monitoring DSO, tool and logwatch files
- Fix ISW Metadata is corrupted after rebuilding is started
- Fix Metadata is not put in the NORMAL state after dmraid
  rebuild is started manually
- Related: rhbz#437169 rhbz#473316 rhbz#474316

* Thu Nov 06 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-16
- Fix RPM build error for unpackaged libdmraid.so
- Resolves: rhbz#437177

* Mon Nov 03 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-15
- Correct for RHEL5 dm-log based error handling
- Related: rhbz#437177

* Fri Sep 26 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-14
- removed regressions: superfluous zlib header include and format
  handler check leading to unaligned accesses on ia64
- Resolves: rhbz#463408

* Wed Sep 17 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-13
- Added missing zlib-devel BuildRequires
- Related: rhbz#437169 rhbz#437173 rhbz#437177 rhbz#439088

* Wed Sep 17 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-12
- Added support for RAID set create/delete/rebuild and event handling
  (Intel contributions); fix patch command to stripe 2 dirs
- Related: rhbz#437169 rhbz#437173 rhbz#437177 rhbz#439088

* Wed Sep 17 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-11
- Added support for RAID set create/delete/rebuild and event handling
  (Intel contributions); fix patch
- Related: rhbz#437169 rhbz#437173 rhbz#437177 rhbz#439088

* Wed Sep 17 2008 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-10
- Added support for RAID set create/delete/rebuild and event handling
  (Intel contributions)
- Resolves: rhbz#437169 rhbz#437173 rhbz#437177 rhbz#439088

* Fri Feb 08 2008 Ian Kent <ikent@redhat.com> - 1.0.0.rc13-9
- Bug 427550: dmraid segfaults on boot resulting in broken mirror
  - patch to fix SEGV when requesting activation of invalid raid set.
  the feature.
  Related: rhbz#427550

* Wed Feb 06 2008 Peter Jones <pjones@redhat.com> - 1.0.0.rc13-8
- Revert fix for 381501, since the RHEL kernel doesn't currently support
  the feature.
  Related: rhbz#381501

* Fri Jan 18 2008 Ian Kent <ikent@redhat.com> - 1.0.0.rc13-7
- fix incorrectly applied patch in spec file.
- Related: rhbz#236891

* Wed Nov 21 2007 Ian Kent <ikent@redhat.com> - 1.0.0.rc13-6
- Bug 381511: dmraid needs to generate UUIDs for lib device-mapper
  - add patch to set UUID.
  - add "DMRAID-" prefix to dmraid UUID string.
- Bug 381501: dmraid needs to activate device-mapper mirror resynchronization error handling
- Resolves: rhbz#381511 rhbz#381501

* Fri Nov 2 2007 Ian Kent <ikent@redhat.com> - 1.0.0.rc13-5
- Fix SEGV on "dmraid -r -E" (bz 236891)
- Resolves: rhbz#236891

* Mon Sep 10 2007 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-4
- Adjusted %dist to rebuild
- Resolves: #211012

* Mon Sep 10 2007 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-4
- Missed a bug with dm map names
- Resolves: #211012

* Tue Jun 26 2007 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-3
- Fix dmraid map names
- Resolves: #211012
- Fix unaligned access messages
  Resolves: #210361, #211150
- Fix jmicron name parsing (bz#219058)

* Wed Nov  8 2006 Peter Jones <pjones@redhat.com> - 1.0.0.rc13-2
- We didn't change the API or ABI, so don't change the version number
  because it'll change the SONAME, which means we have to needlessly rebuild
  other packages.

* Wed Nov 08 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc14-1
- asr.c: fixed Adaptec HostRAID DDF1 metadata discovery (bz#211016)
- ddf1_crc.c: added crc() routine to avoid linking to zlib alltogether,
              because Ubuntu had problems with this
- dropped zlib build requirement

* Thu Oct 26 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc14-bz211016-1
- ddf1.c: get_size() fixed (bz#211016)
- ddf1_lib.c: ddf1_cr_off_maxpds_helper() fixed (bz#211016)

* Wed Oct 11 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc13-1
- metadata.c: fixed bug returning wrang unified RAID type (bz#210085)
- pdc.c: fixed magic number check

* Sun Oct 01 2006 Jesse Keating <jkeating@redhat.com> - 1.0.0.rc12-7
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Fri Sep 22 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc12-1
- sil.c: quorate() OBO fix
- activate.c: handler() OBO fix
- added SNIA DDF1 support
- added reload functionality to devmapper.c
- added log_zero_sectors() to various metadata format handlers
- sil.[ch]: added JBOD support

* Fri Sep  1 2006 Peter Jones <pjones@redhat.com> - 1.0.0.rc11-4
- Require kpartx, so initscripts doesn't have to if you're not using dmraid

* Thu Aug 17 2006 Jesse Keating <jkeating@redhat.com> - 1.0.0.rc11-3
- Change Release to follow guidelines, and add dist tag.

* Thu Aug 17 2006 Peter Jones <pjones@redhat.com> - 1.0.0.rc11-FC6.3
- No more excludearch for s390/s390x

* Fri Jul 28 2006 Peter Jones <pjones@redhat.com> - 1.0.0.rc11-FC6.2
- Fix bounds checking on hpt37x error log
- Only build the .so, not the .a
- Fix asc.c duplication in makefile rule

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 1.0.0.rc11-FC6.1.1
- rebuild

* Fri Jul  7 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc11-FC6.1
- rebuilt for FC6 with dos partition discovery fix (#197573)

* Tue May 16 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc11-FC6
- rebuilt for FC6 with better tag

* Tue May 16 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc11-FC5_7.2
- rebuilt for FC5

* Tue May 16 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc11-FC5_7.1
- jm.c: checksum() calculation
- misc.c: support "%d" in p_fmt and fix segfault with wrong format identifier
- nv.c: size fix in setup_rd()
- activate.c:
        o striped devices could end on non-chunk boundaries
        o calc_region_size() calculated too small sizes causing large
          dirty logs in memory
- isw.c: set raid5 type to left asymmetric
- toollib.c: fixed 'No RAID...' message
- support selection of RAID5 allocation algorithm in metadata format handlers
- build

* Mon Mar 27 2006 Milan Broz <mbroz@redhat.com> - 1.0.0.rc10-FC5_6.2
- fixed /var/lock/dmraid in specfile (#168195)

* Fri Feb 17 2006 Heinz Mauelshagen <heinzm@redhat.com> - 1.0.0.rc10-FC5_6
- add doc/dmraid_design.txt to %doc (#181885)
- add --enable-libselinux --enable-libsepol to configure
- rebuilt

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 1.0.0.rc9-FC5_5.2
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 1.0.0.rc9-FC5_5.1
- rebuilt for new gcc4.1 snapshot and glibc changes

* Sun Jan 22 2006 Peter Jones <pjones@redhat.com> 1.0.0.rc9-FC5_5
- Add selinux build deps
- Don't set owner during make install

* Fri Dec  9 2005 Jesse Keating <jkeating@redhat.com> 1.0.0.rc9-FC5_4.1
- rebuilt

* Sun Dec  3 2005 Peter Jones <pjones@redhat.com> 1.0.0.rc9-FC5_4
- rebuild for device-mapper-1.02.02-2

* Fri Dec  2 2005 Peter Jones <pjones@redhat.com> 1.0.0.rc9-FC5_3
- rebuild for device-mapper-1.02.02-1

* Thu Nov 10 2005 Peter Jones <pjones@redhat.com> 1.0.0.rc9-FC5_2
- update to 1.0.0.rc9
- make "make install" do the right thing with the DSO
- eliminate duplicate definitions in the headers
- export more symbols in the DSO
- add api calls to retrieve dm tables
- fix DESTDIR for 'make install' 
- add api calls to identify degraded devices
- remove several arch excludes

* Sat Oct 15 2005 Florian La Roche <laroche@redhat.com>
- add -lselinux -lsepol for new device-mapper deps

* Fri May 20 2005 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0.rc8-FC4_2
- specfile change to build static and dynamic binray into one package
- rebuilt

* Thu May 19 2005 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0.rc8-FC4_1
- nv.c: fixed stripe size
- sil.c: avoid incarnation_no in name creation, because the Windows
         driver changes it every time
- added --ignorelocking option to avoid taking out locks in early boot
  where no read/write access to /var is given

* Wed Mar 16 2005 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Tue Mar 15 2005 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0.rc6.1-4_FC4
- VIA metadata format handler
- added RAID10 to lsi metadata format handler
- "dmraid -rD": file device size into {devicename}_{formatname}.size
- "dmraid -tay": pretty print multi-line tables ala "dmsetup table"
- "dmraid -l": display supported RAID levels + manual update
- _sil_read() used LOG_NOTICE rather than LOG_INFO in order to
  avoid messages about valid metadata areas being displayed
  during "dmraid -vay".
- isw, sil filed metadata offset on "-r -D" in sectors rather than in bytes.
- isw needed dev_sort() to sort RAID devices in sets correctly.
- pdc metadata format handler name creation. Lead to
  wrong RAID set grouping logic in some configurations.
- pdc RAID1 size calculation fixed (rc6.1)
- dos.c: partition table code fixes by Paul Moore
- _free_dev_pointers(): fixed potential OOB error
- hpt37x_check: deal with raid_disks = 1 in mirror sets
- pdc_check: status & 0x80 doesn't always show a failed device;
  removed that check for now. Status definitions needed.
- sil addition of RAID sets to global list of sets
- sil spare device memory leak
- group_set(): removal of RAID set in case of error
- hpt37x: handle total_secs > device size
- allow -p with -f
- enhanced error message by checking target type against list of
  registered target types

* Fri Jan 21 2005 Alasdair Kergon <agk@redhat.com> 1.0.0.rc5f-2
- Rebuild to pick up new libdevmapper.

* Fri Nov 26 2004 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0.rc5f
- specfile cleanup

* Tue Aug 20 2004 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0-rc4-pre1
- Removed make flag after fixing make.tmpl.in

* Tue Aug 18 2004 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0-rc3
- Added make flag to prevent make 3.80 from looping infinitely

* Thu Jun 17 2004 Heinz Mauelshagen <heinzm@redhat.com> 1.0.0-pre1
- Created
